# PASN_Real Class Reference

Class for ASN floating point type. More...

`#include <asner.h>`

Inheritance diagram for PASN_Real:

List of all members.

## Public Member Functions

| PASN_Real (double val=0)
| PASN_Real (unsigned tag, TagClass tagClass, double val=0)
PASN_Real & | operator= (double val)
| operator double () const
double | GetValue () const
void | SetValue (double v)
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank.
virtual PObject * | Clone () const
| Create a copy of the class on the heap.
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream.
virtual PString | GetTypeAsString () const
| Return a string giving the type of the object.
virtual PINDEX | GetDataLength () const
virtual PBoolean | Decode (PASN_Stream &)
virtual void | Encode (PASN_Stream &) const

## Protected Attributes

double | value

## Detailed Description

Class for ASN floating point type.

## Constructor & Destructor Documentation

PASN_Real::PASN_Real | ( | double | val = `0` | ) |

PASN_Real::PASN_Real | ( | unsigned | tag,
|  | TagClass | tagClass,
|  | double | val = `0` |
| ) |  |  |

## Member Function Documentation

virtual PObject* PASN_Real::Clone | ( |  | ) | const`[virtual]`

Create a copy of the class on the heap.

The exact semantics of the descendent class determine what is required to make a duplicate of the instance. Not all classes can even do a clone operation.

The main user of the clone function is the `PDictionary` class as it requires copies of the dictionary keys.

The default behaviour is for this function to assert.

Returns:
  pointer to new copy of the class instance.

Reimplemented from PObject.

virtual Comparison PASN_Real::Compare | ( | const PObject & | obj | ) | const`[virtual]`

Compare the two objects and return their relative rank.

This function is usually overridden by descendent classes to yield the ranking according to the semantics of the object.

The default function is to use the `CompareObjectMemoryDirect()` function to do a byte wise memory comparison of the two objects.

Returns:
  `LessThan`, `EqualTo` or `GreaterThan` according to the relative rank of the objects.

Reimplemented from PObject.

virtual PBoolean PASN_Real::Decode | ( | PASN_Stream & |  | ) | `[virtual]`

Implements PASN_Object.

virtual void PASN_Real::Encode | ( | PASN_Stream & |  | ) | const`[virtual]`

Implements PASN_Object.

virtual PINDEX PASN_Real::GetDataLength | ( |  | ) | const`[virtual]`

Implements PASN_Object.

virtual PString PASN_Real::GetTypeAsString | ( |  | ) | const`[virtual]`

Return a string giving the type of the object.

Implements PASN_Object.

double PASN_Real::GetValue | ( |  | ) | const`[inline]`

PASN_Real::operator double | ( |  | ) | const`[inline]`

PASN_Real& PASN_Real::operator= | ( | double | val | ) | `[inline]`

virtual void PASN_Real::PrintOn | ( | ostream & | strm | ) | const`[virtual]`

Output the contents of the object to the stream.

The exact output is dependent on the exact semantics of the descendent class. This is primarily used by the standard `operator<<` function.

The default behaviour is to print the class name.

Reimplemented from PObject.

void PASN_Real::SetValue | ( | double | v | ) | `[inline]`

## Member Data Documentation

double PASN_Real::value `[protected]`

The documentation for this class was generated from the following file:

- asner.h